#include <iostream>
#include <cmath>

using namespace std;

void analyzeDividors(int num, int &outCountDivs, int &outSumDivs);

bool isPerfect(int num);


int main() {
    int num;
    cout << "Enter a positive integer >= 2: ";
    cin >> num;

    // output perfect numbers between 2 and `num`
    int cnt_perfect = 0;
    for (int i = 2; i <= num; i++) {
        if (isPerfect(i)) {
            cnt_perfect++;
            if (cnt_perfect == 1) cout << "Perfect numbers:\n";
            cout << i << " ";
        }
    }

    if (cnt_perfect == 0) cout << "There is no perfect number.";
    cout << endl;

    // output amicable numbers bewtween 2 and `num`
    int i = 2, cnt_pairs = 0;
    while (i <= num) {
        int outCountDivs = 1, outSumDivs = 1;
        analyzeDividors(i, outCountDivs, outSumDivs);

        if (outSumDivs <= num && outSumDivs >= 2) {
            int outCountDivs2 = 1, outSumDivs2 = 1;
            analyzeDividors(outSumDivs, outCountDivs2, outSumDivs2);

            if (outSumDivs2 == i && i < outSumDivs) {
                cnt_pairs++;
                if (cnt_pairs == 1) cout << "Pairs of amicable numbers:\n";
                cout << "(" << i << ", " << outSumDivs << ")" << endl;
            }
        }
        i++;
    }
    if (cnt_pairs == 0) cout << "There is no amicable number.\n";

    return 0;
}

void analyzeDividors(int num, int &outCountDivs, int &outSumDivs) {
    for (int i = 2; i <= sqrt(num); i++) {
        if (num % i == 0) {
            outSumDivs += i;
            outCountDivs++;
            if (i != sqrt(num)) {
                outSumDivs += num / i;
                outCountDivs++;
            }
        }
    }
}

bool isPerfect(int num) {
    int outCountDivs = 1, outSumDivs = 1;
    analyzeDividors(num, outCountDivs, outSumDivs);
    return num == outSumDivs;
}